_G.lower_menu_fps = {}

lower_menu_fps._id = "Lower Menu FPS"
lower_menu_fps._path = ModPath
lower_menu_fps._save_path = SavePath .. "lower_menu_fps.json"
lower_menu_fps._data = {
	fps = 60
}

function lower_menu_fps:save()
	local file = io.open(self._save_path, 'w+')
	
	if file then
		file:write(json.encode(self._data))
		file:close()
	end
end

function lower_menu_fps:load()
	local file = io.open(self._save_path, "r")

	if file then
		self._data = json.decode(file:read("*all"))
		file:close()
	end
end

local menu_id = lower_menu_fps._id

Hooks:Add("MenuManagerSetupCustomMenus", lower_menu_fps._id .. " --> MenuManagerSetupCustomMenus", function()
	MenuHelper:NewMenu(menu_id)
end)

Hooks:Add("LocalizationManagerPostInit", lower_menu_fps._id .. " --> LocalizationManagerPostInit", function(loc)
	loc:load_localization_file(lower_menu_fps._path .. "loc/en.json")
end)

Hooks:Add("MenuManagerBuildCustomMenus", lower_menu_fps._id .. " --> MenuManagerBuildCustomMenus", function(_, nodes)
	nodes[menu_id] = MenuHelper:BuildMenu(menu_id)
	MenuHelper:AddMenuItem(nodes[BLT.Mods.Constants:LuaModOptionsMenuID()], menu_id, "lower_menu_fps_menu_name", "lower_menu_fps_menu_desc")
end)

function MenuCallbackHandler:lower_menu_fps_slider_callback(item)
	local selected_item = item._parameters.name:match("lower_menu_fps_(.-)_slider")
	
	lower_menu_fps._data[selected_item] = item._value
	lower_menu_fps:save()
end

Hooks:Add("MenuManagerPopulateCustomMenus", lower_menu_fps._id .. " --> MenuManagerPopulateCustomMenus", function(menu_manager, nodes)
	lower_menu_fps:load()

	local refresh_rate = nil
	
	for _, res in ipairs(RenderSettings.modes) do
		refresh_rate = (not refresh_rate or res.z > refresh_rate) and res.z or refresh_rate
	end
	
	refresh_rate = refresh_rate or 1000
	
	MenuHelper:AddSlider({
		id = "lower_menu_fps_fps_slider",
		title = "lower_menu_fps_fps_slider_name",
		desc = "lower_menu_fps_fps_slider_desc",
		callback = "lower_menu_fps_slider_callback",
		value = lower_menu_fps._data.fps,
		min = 30,
		max = refresh_rate,
		step = 1,
		show_value = true,
		menu_id = menu_id
	})
	
	lower_menu_fps:save()
end)